"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.getMarkets = exports.getUserBalance = void 0;
var endpoint = function (chainId) {
    if (chainId === 31)
        return "https://graphql1.testnet.tropykus.com";
    return "https://graphql1.tropykus.com";
};
var headers = {
    "content-type": "application/json"
};
/**
 * Retrieves the user ID for a given user address.
 * @param user_address The user address to search for.
 * @returns A Promise that resolves to the first user matching the provided address, or null if no user is found.
 */
var getUserId = function (user_address, chainId) { return __awaiter(void 0, void 0, void 0, function () {
    var query, variables, graphqlQuery, options, response, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                query = "\n\tquery FindFirstUsers($where: UsersWhereInput) {\n\t\tfindFirstUsers(where: $where) {\n\t\taddress\n\t\tid\n\t\t}\n\t}";
                variables = {
                    where: {
                        address_lowercase: {
                            equals: user_address.toLowerCase()
                        }
                    }
                };
                graphqlQuery = {
                    operationName: "FindFirstUsers",
                    query: query,
                    variables: variables
                };
                options = {
                    method: "POST",
                    headers: headers,
                    body: JSON.stringify(graphqlQuery)
                };
                _a.label = 1;
            case 1:
                _a.trys.push([1, 4, , 5]);
                return [4 /*yield*/, fetch(endpoint(chainId), options)];
            case 2:
                response = _a.sent();
                return [4 /*yield*/, response.json()];
            case 3: return [2 /*return*/, _a.sent()];
            case 4:
                error_1 = _a.sent();
                console.error("Error fetching user balance", error_1);
                return [2 /*return*/, null];
            case 5: return [2 /*return*/];
        }
    });
}); };
/**
 * Retrieves the balance of a user.
 * @param user_address The address of the user.
 * @returns A promise that resolves to an object containing the user's balance data, or null if the user is not found. The balance data includes the user's deposits, borrows, and interest for each market.
 */
exports.getUserBalance = function (user_address, chainId) { return __awaiter(void 0, void 0, void 0, function () {
    var userIdResponse, userId, query, variables, graphqlQuery, options, response, userData, marketsBalance, marketsBalanceFiltered, userBalances, error_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, getUserId(user_address, chainId)];
            case 1:
                userIdResponse = _a.sent();
                if (!userIdResponse)
                    throw new Error("User not found");
                userId = userIdResponse.data.findFirstUsers.id;
                query = "\n        query getUserBalance($where: User_balancesWhereInput) {\n            findManyUser_balances(where: $where) {\n                market_id\n                deposits\n                brute_deposits\n                borrows\n                brute_borrows\n                markets {\n                    market_type\n                    contract_address\n                    name\n                    id\n                    is_listed\n                }\n            }\n        }\n    ";
                variables = {
                    where: {
                        user_id: {
                            equals: userId
                        }
                    }
                };
                graphqlQuery = {
                    operationName: "getUserBalance",
                    query: query,
                    variables: variables
                };
                options = {
                    method: "POST",
                    headers: headers,
                    body: JSON.stringify(graphqlQuery)
                };
                _a.label = 2;
            case 2:
                _a.trys.push([2, 5, , 6]);
                return [4 /*yield*/, fetch(endpoint(chainId), options)];
            case 3:
                response = _a.sent();
                return [4 /*yield*/, response.json()];
            case 4:
                userData = _a.sent();
                marketsBalance = userData.data.findManyUser_balances;
                marketsBalanceFiltered = marketsBalance.filter(function (mkt) { return mkt.markets.is_listed; });
                userBalances = marketsBalanceFiltered.map(function (mkt) {
                    return {
                        market: mkt.markets.name,
                        deposits: mkt.deposits,
                        borrows: mkt.borrows,
                        depositsInterest: mkt.deposits - mkt.brute_deposits,
                        borrowInterest: mkt.borrows - mkt.brute_borrows
                    };
                });
                return [2 /*return*/, { data: userBalances }];
            case 5:
                error_2 = _a.sent();
                console.error("Error fetching user balance", error_2);
                return [2 /*return*/, null];
            case 6: return [2 /*return*/];
        }
    });
}); };
/**
 * Retrieves a list of markets from the server.
 * @param chainId - The ID of the chain to fetch the markets from.
 * @returns A promise that resolves to the list of markets, or null if an error occurs.
 */
exports.getMarkets = function (chainId) { return __awaiter(void 0, void 0, void 0, function () {
    var query, variables, graphqlQuery, options, response, error_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                query = "\n\tquery getMarkets($where: MarketsWhereInput) {\n\tfindManyMarkets(where: $where) {\n\t\tid\n\t\tname\n\t\tborrow_rate\n\t\ttotal_borrows\n\t\ttotal_supply\n\t\tunderlying_token_price\n\t\tunderlying_token_address\n\t\tcontract_address\n\t\tsupply_rate\n\t\t}\n\t}";
                variables = {
                    where: {
                        is_listed: {
                            equals: true
                        }
                    }
                };
                graphqlQuery = {
                    operationName: "getMarkets",
                    query: query,
                    variables: variables
                };
                options = {
                    method: "POST",
                    headers: headers,
                    body: JSON.stringify(graphqlQuery)
                };
                _a.label = 1;
            case 1:
                _a.trys.push([1, 4, , 5]);
                return [4 /*yield*/, fetch(endpoint(chainId), options)];
            case 2:
                response = _a.sent();
                return [4 /*yield*/, response.json()];
            case 3: return [2 /*return*/, _a.sent()];
            case 4:
                error_3 = _a.sent();
                console.error("Error fetching markets", error_3);
                return [2 /*return*/, null];
            case 5: return [2 /*return*/];
        }
    });
}); };
//# sourceMappingURL=api.js.map