import { CompoundInstance } from "./types";
/**
 * This function acts like a decorator for all methods that interact with the
 *     blockchain. In order to use the correct Compound Protocol addresses, the
 *     Compound.js SDK must know which network its provider points to. This
 *     function holds up a transaction until the main constructor has determined
 *     the network ID.
 *
 * @hidden
 *
 * @param {Compound } instance The Compound (v2) or Comet instance of the SDK.
 *
 */
export declare function netId(instance: CompoundInstance): Promise<void>;
/**
 * Applies the EIP-55 checksum to an Ethereum address.
 *
 * @hidden
 *
 * @param {string} _address The Ethereum address to apply the checksum.
 *
 * @returns {string} Returns a string of the Ethereum address.
 */
export declare function toChecksumAddress(_address: string): string;
